#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "emoji-chooser.h"

void emoji_picked(void* instance, gchar* text, void* entry)
{
	g_signal_emit_by_name(entry, "insert-at-cursor", text, NULL);
}

int main(int argc,char** argv)
{
	gtk_init(&argc, &argv);
	
	gtk_test_register_all_types();
	
	GtkWidget* window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	GtkWidget* entry = gtk_entry_new();
	GObject* obj = g_object_new(GTK_TYPE_EMOJI_CHOOSER, NULL);
	gtk_widget_show_all(GTK_WIDGET(obj));
	GtkWidget* box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0);

	gtk_container_add(GTK_CONTAINER(window), box);
	gtk_container_add(GTK_CONTAINER(box), entry);
	gtk_container_add(GTK_CONTAINER(box), GTK_WIDGET(obj));

	g_signal_connect(obj, "emoji-picked", G_CALLBACK(emoji_picked), entry);

	gtk_widget_show_all(window);
	
	gtk_main();
}
